﻿'=========================================================
'Description : USB Seriel product demo program for VB.NET
'DLL Version : USBDII.dll V 2.0.0.1
'Release Date : 2009/09/01
'Author : Samuel Tseng
'
'Copyright 2009 Decision Computer
'All Right Reserved
'=========================================================

Public Class Form1

    'USBDII.dll External function import
    '

    Private Declare Function hid_OpenDevice Lib "USBDII" Alias "_hid_OpenDevice@8" _
     (ByVal card_type As Integer, ByVal card_id As Integer) As Integer
    Private Declare Function hid_SetDigitalByte Lib "USBDII" Alias "_hid_SetDigitalByte@12" _
     (ByVal hUSB As Integer, ByVal address As Integer, ByVal data As Byte) As Boolean
    Private Declare Function hid_GetDigitalByte Lib "USBDII" Alias "_hid_GetDigitalByte@12" _
     (ByVal hUSB As Integer, ByVal address As Integer, ByRef data As Integer) As Boolean
    Private Declare Function hid_CloseDevice Lib "USBDII" Alias "_hid_CloseDevice@4" _
     (ByVal hUSB As Integer) As Boolean
    Private Declare Function hid_GetAnalogChannel Lib "USBDII" Alias "_hid_GetAnalogChannel@12" _
     (ByVal hUSB As Integer, ByVal address As Integer, ByRef data As Integer) As Boolean


    Private Declare Function com_OpenDevice Lib "USBDII" Alias "_com_OpenDevice@12" _
     (ByVal card_type As Integer, ByVal card_id As Integer, ByVal com_num As Integer) As Integer
    Private Declare Function com_SetDigitalByte Lib "USBDII" Alias "_com_SetDigitalByte@12" _
     (ByVal hCOM As Integer, ByVal address As Integer, ByVal data As Byte) As Boolean
    Private Declare Function com_GetDigitalByte Lib "USBDII" Alias "_com_GetDigitalByte@12" _
     (ByVal hCOM As Integer, ByVal address As Integer, ByRef data As Integer) As Boolean
    Private Declare Function com_CloseDevice Lib "USBDII" Alias "_com_CloseDevice@4" _
     (ByVal hCOM As Integer) As Boolean

    Dim hDevice As Integer                  ' handle to device
    Dim DevType As Integer
    Dim DevId As Integer
    Dim DevCom As Integer
    Dim Mode As Boolean
    Dim TypeNum(12) As Integer
    Dim inData As Integer
    Dim outData As Byte
    Dim IsLABKIT, Is8PR As Boolean
    Dim lResult As Boolean


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'USB_16PIO   0x01
        'USB_LABKIT  0x02
        'USB_16PR    0x03
        'USB_14ADDA  0x05
        'USB_8PR     0x06
        'USB_4PR     0x07
        'USB_8PI     0x08
        'USB_8RO     0x09
        'USB_16PI    0x0A
        'USB_16RO    0x0B
        'USB_32PI    0x0C
        'USB_32RO    0x0D

        TypeNum(0) = 2  'TypeNum Define of USB LAB KIT
        TypeNum(1) = 7  'TypeNum Define of USB 4 Photo Input / Relay Output Board
        TypeNum(2) = 8  'TypeNum Define of USB 8 Photo Input Board
        TypeNum(3) = 9  'TypeNum Define of USB 8 Relay Output Board
        TypeNum(4) = 6  'TypeNum Define of USB 8 Photo Input / Relay Output Board
        TypeNum(5) = 10 'TypeNum Define of USB 16 Photo Input Board
        TypeNum(6) = 11 'TypeNum Define of USB 16 Relay Output Board
        TypeNum(7) = 3  'TypeNum Define of USB 16 Photo Input / Relay Output Board
        TypeNum(8) = 1  'TypeNum Define of USB 16 Photo Input / Output Board
        TypeNum(9) = 12 'TypeNum Define of USB 32 Photo Input Board
        TypeNum(10) = 13 'TypeNum Define of USB 32 Relay Output Board
        TypeNum(11) = 5 'TypeNum Define of USB 14 AD/DA Board

        hDevice = -1
        Mode = True
        DeviceCom.Visible = False

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        DevId = DeviceNum.SelectedIndex
        DevType = TypeNum(DeviceType.SelectedIndex)

        If Not Mode Then
            DevCom = DeviceCom.SelectedIndex + 1
        End If


        IsLABKIT = False
        Is8PR = False

        If DevType = 2 Then
            IsLABKIT = True
        End If
        If DevType = 6 Then
            Is8PR = True
        End If


        If Mode Then
            hDevice = hid_OpenDevice(DevType, DevId)  'select device by user
        Else
            hDevice = com_OpenDevice(DevType, DevId, DevCom)
        End If

        If hDevice = -1 Then 'open error

            Text1.Text = "Fail to get device base address"
        Else
            Text1.Text = "Open Success"
            Button1.Enabled = False
            If Not Mode Then Timer1.Enabled = True
        End If

        If IsLABKIT Then
            Button7.Enabled = True
        Else
            Button7.Enabled = False
        End If


        If Is8PR Then
            Button8.Enabled = True
        Else
            Button8.Enabled = False
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        If hDevice = -1 Then Exit Sub

        If Mode Then
            lResult = hid_GetDigitalByte(hDevice, 0, inData)
        Else
            lResult = com_GetDigitalByte(hDevice, 0, inData)
        End If


        If lResult Then

            Text1.Text = "Port0 =" + Str(inData)
        Else
            Text1.Text = "Port0 Read Error"

        End If

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        If hDevice = -1 Then Exit Sub

        If Mode Then
            lResult = hid_GetDigitalByte(hDevice, 1, inData)
        Else
            lResult = com_GetDigitalByte(hDevice, 1, inData)
        End If

        If lResult Then
            Text1.Text = "Port1 =" + Str(inData)
        Else
            Text1.Text = "Port1 Read Error"

        End If

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        If hDevice = -1 Then Exit Sub

        outData = 1

        If Mode Then
            lResult = hid_SetDigitalByte(hDevice, 2, outData)
        Else
            lResult = com_SetDigitalByte(hDevice, 2, outData)
        End If

        If lResult Then
            Text1.Text = "Port2 =" + Str(outData)
        Else
            Text1.Text = "Port2 Write Error"

        End If

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        If hDevice = -1 Then Exit Sub

        outData = 3

        If Mode Then
            lResult = hid_SetDigitalByte(hDevice, 3, outData)
        Else
            lResult = com_SetDigitalByte(hDevice, 3, outData)
        End If

        If lResult Then
            Text1.Text = "Port3 =" + Str(outData)
        Else
            Text1.Text = "Port3 Write Error"

        End If

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click

        If hDevice = -1 Then Exit Sub

        If Mode Then
            hid_CloseDevice(hDevice)
        Else
            com_CloseDevice(hDevice)
        End If

        hDevice = -1

        Text1.Text = "Device Close"
        Button1.Enabled = True
        Timer1.Enabled = False

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click

        Dim I, ADVAlue As Integer

        If hDevice = -1 Then Exit Sub

        If hid_GetAnalogChannel(hDevice, I, ADVAlue) Then
            Text1.Text = "AD#0 =" + Str(ADVAlue)
        End If

    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click

        Dim inData As Integer
        Dim msg1, msg2 As String

        If hDevice = -1 Then Exit Sub

        If Mode Then
            lResult = hid_GetDigitalByte(hDevice, &H10, inData)
        Else
            lResult = hid_GetDigitalByte(hDevice, &H10, inData)
        End If

        If lResult Then

            If (inData And &H10) = 0 Then

                msg1 = "JP10 is close DIO0-DIO7 is for input    "

            Else

                msg1 = "JP10 is open DIO0-DIO7 is for output  "

            End If

            If (inData And &H20) = 0 Then

                msg2 = "JP11 is close DIO15-DIO8 is for input   "

            Else
                msg2 = "JP11 is open DIO15-DIO8 is for output "
            End If


            Text1.Text = msg1 + msg2


        End If
    End Sub


    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        Mode = False
        DeviceCom.Visible = True
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        Mode = True
        DeviceCom.Visible = False
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim temp As Integer

        ' keep polling to build serial communication

        lResult = com_GetDigitalByte(hDevice, 0, temp)
    End Sub
End Class
